using System;

namespace cz.msdn.Piskvorky.Definice
{
	/// <summary>
	/// Rozhran definujc funkci hracho enginu.
	/// </summary>
	public interface IEngine
	{
		/// <summary>
		/// Nalezeni nejlepsiho tahu v dan situaci.
		/// </summary>
		/// <param name="hraciPole">Hrac pole jako dvourozmrn tvercov pole o velikosti HraciPlocha.VelikostPlochy</param>
		/// <param name="barvaNaTahu">Barva kamene, kter je prv na tahu.</param>
		/// <param name="zbyvajiciCasNaPartii">as, kter m jet engine k dispozici na vechny zbvajc tahy v partii. Engine, kter vechen as vyerp jako prvn, prohrv partii. Hodnotu zbyvajiciCasNaPartii dostv engine od programu-rozhodho zpasu a pro vsledek zpasu je smrodatn men provdn poadateli, proto by ml program zachzet s tmto asem s jistou malou toleranc, kter eliminuje ppadn drobn odchylky v men.</param>
		/// <returns>Souadnice zvolen enginem jako nejlep tah.</returns> 
		SouradnicePole NajdiNejlepsiTah(BarvaKamene[,] hraciPole, BarvaKamene barvaNaTahu, TimeSpan zbyvajiciCasNaPartii);
	}
}
